%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%%%----------------------------------------------------------------------
%%% File    : debugger.erl
%%% Author  : Peter Olin <olin@smaug>
%%% Purpose : Exported API to the DEBUGGER GUI.
%%% Created :  7 May 1998 by Peter Olin <olin@smaug>
%%%----------------------------------------------------------------------

-module(debugger).

-export([
	 start/0,
	 start_timeout/1,
	 init/0,
	 q/3,
	 quick/3,
	 a_start/3,
	 a_start/4,
	 attach_menus/1
	]).



%% start/0 - starts the DEBUGGER by opening the monitor window.
%% This function is intended to be called by the end user from the Erlang 
%% shell. It will take the time it takes to start the DEBUGGER.

start() ->
    dbg_ui_mon:start_timeout(infinity).


%% start_timeont/1 - starts the DEBUGGER by opening the monitor window.
%% This function is intended as the API for programs that wants to start
%% the DEBUGGER. The Timeout parameter specifies how many milliseconds to 
%% wait before Exiting with a {startup_timeout, ?MODULE} EXIT reason.

start_timeout(Timeout) ->
    dbg_ui_mon:start_timeout(Timeout).



init() ->
    dbg_ui_mon:init().


attach_menus(A) ->
    dbg_ui_mon:attach_menus(A).




a_start(A,B,C) ->
    dbg_ui_trace:a_start(A,B,C).
    
a_start(A,B,C,D) ->
    dbg_ui_trace:a_start(A,B,C,D).




%%
%% quick start a module
%%

quick (Module, Fun, Args) ->
    dbg_ui_mon:quick (Module, Fun, Args).


q (Module, Fun, Args) ->
    dbg_ui_mon:quick (Module, Fun, Args).

