%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%% ------------------------------------------------------------
%% A simple demo for choosing
%% colors in a window.
%%
%% Written by Ola Samuelsson in july 1995
%%  Ericsson Infocom Consultants AB / Erlang Systems Division
%% ------------------------------------------------------------

-module(color_demo).
-copyright('Copyright (c) 1991-97 Ericsson Telecom AB').
-vsn('$Revision: /main/release/free/1').
-revision('$Revision: 1.2 $').
-author('ola@erlang.ericsson.se').
-modified('$Date: 1996/06/03 15:50:52 $').
-modified_by('$Author: anders $').

-export([start/0,init/0]).

start() ->
    spawn(color_demo,init,[]).

init() ->
    I= gs:start(),
    W= gs:window(I,[{title,"Color Demo"},{width,300},{height,195}]), 
    B=gs:button(W,[{bitmap,"die_icon"},{x,271},{y,166},{width,30}]),
    gs:config(B,[{bg,yellow},{fg,hotpink1},{data,quit}]),
    gs:scale(W,[{text,"Red"},{y,0},{range,{0,255}},{orient,horizontal},
		{height,65},{data,red},{pos,42}]),
    gs:scale(W,[{text,"Blue"},{y,65},{range,{0,255}},{orient,horizontal},
		{height,65},{data,blue},{pos,42}]),
    gs:scale(W,[{text,"Green"},{y,130},{range,{0,255}},{orient,horizontal},
		{height,65},{data,green},{pos,42}]),
    gs:config(W,{map,true}),
    loop(W,0,0,0).

loop(W,R,G,B) ->
    gs:config(W,{bg,{R,G,B}}),
    receive
	{gs,_,click,red,[New_R|_]} ->
	    loop(W,New_R,G,B);
	{gs,_,click,green,[New_G|_]} ->
	    loop(W,R,New_G,B);
	{gs,_,click,blue,[New_B|_]} ->
	    loop(W,R,G,New_B);
	{gs,_,click,quit,_} ->
	    true;
	{gs,W,destroy,_,_} ->
	    true
    end.

%% ------------------------------------------------------------
