%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%% ------------------------------------------------------------
%%  Entry Demo
%%
%% Written by Ola Samuelsson in August 1995
%%  Ericsson Infocom Consultants AB / Erlang Systems Division
%% ------------------------------------------------------------

-module(entry_demo).
-copyright('Copyright (c) 1991-97 Ericsson Telecom AB').
-vsn('$Revision: /main/release/free/1').
-revision('$Revision: 1.1 $').
-author('ola@erlang.ericsson.se').
-modified('$Date: 1996/05/08 08:22:26 $').
-modified_by('$Author: anders $').

-export([start/0,init/1]).

start() ->
    spawn(entry_demo,init,[self()]),
    receive
	{entry_reply,Reply} -> Reply
    end.

init(Pid) ->
    S=gs:start(),
    Win=gs:window(S,[{title,"Entry Demo"},{width,150},{height,100}]),
    gs:create(label,Win,[{width,150},{label,{text,"What's your name?"}}]),
    gs:create(entry,entry,Win,[{x,10},{y,30},{width,130},{keypress,true}]),
    gs:create(button,ok,Win,[{width,45},{y,60},{x,10},{label,{text,"Ok"}}]),
    gs:create(button,cancel,Win,[{width,60},{y,60},{x,80},{label,{text,"Cancel"}}]),
    gs:config(Win,{map,true}),
    loop(Pid).

loop(Pid) ->
    receive
	{gs,entry,keypress,_,['Return'|_]} ->
	    Text=gs:read(entry,text),
	    Pid ! {entry_reply,{name,Text}};
	{gs,entry,keypress,_,_} ->
	    loop(Pid);
	{gs,ok,click,_,_} ->
	    Text=gs:read(entry,text),
	    Pid ! {entry_reply,{name,Text}};
	{gs,cancel,click,_,_} ->
	    Pid ! {entry_reply,cancel};
	X ->
	    io:format("Got X=~w~n",[X]),
	    loop(Pid)
    end.

%% ----------------------------------------
%% done
