%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
-module(menu_demo).
-copyright('Copyright (c) 1991-97 Ericsson Telecom AB').
-vsn('$Revision: /main/release/free/1').
-revision('$Revision: 1.2 $').
-author('eklas@erlang.ericsson.se').
-modified('$Date: 1996/06/18 16:57:50 $').
-modified_by('$Author: eklas $').

-compile(export_all).

start() -> spawn(menu_demo, init, []).

init() ->
    I=gs:start(),
    Win=gs:window(I, [{title,"menu"},{width,200},{height,100}, {map, true}]),
    Bar = gs:create(menubar, Win, []),
    Fmb = gs:create(menubutton, Bar, [{label, {text, "File"}}]),
    Emb = gs:create(menubutton, Bar, [{label, {text, "Edit"}}]),
    Hmb = gs:create(menubutton, Bar, [{label, {text, "Help"}}, {side, right}]),
    Fmnu = gs:create(menu, Fmb, []),
    Emnu = gs:create(menu, Emb, []),
    Hmnu = gs:create(menu, Hmb, []),
    gs:create(menuitem, load, Fmnu, [{label,{text, "Load"}}]),
    gs:create(menuitem, save, Fmnu, [{label,{text, "Save"}}]),
    Exit = gs:create(menuitem, Fmnu, [{label,{text, "Exit"}}]),
    Color=gs:create(menuitem,Emnu,[{label,{text,"Color"}},{itemtype,cascade}]),
    Cmnu = gs:create(menu, Color, [{disabledfg,gray}]),
    gs:create(menuitem, Cmnu, [{label, {text,"Red"}}, {data, {new_color, red}},
			       {fg,red}, {itemtype,radio},{group,gr1}]),
    gs:create(menuitem, Cmnu, [{label, {text,"Blue"}},{data, {new_color, blue}},
			       {fg,blue}, {itemtype,radio},{group,gr1}]),
    gs:create(menuitem,Cmnu,[{label, {text,"Black"}},{data, {new_color, black}},
			      {fg,black}, {itemtype,radio},{group,gr1}]),
    Y = gs:create(menuitem, Hmnu, [{label, {text,"You"}}, {itemtype, check}]),
    M = gs:create(menuitem,me,Hmnu,[{label,{text,"Me"}},{itemtype,check}]),
    gs:create(menuitem, Hmnu, [{label, {text, "Other"}}, {itemtype, check},
			       {enable,false},{click,false}]),
    gs:create(menuitem,doit,Hmnu,[{label,{text,"Doit!"}},{data,{doit,Y,M}}]),
    loop(Exit, Win).

loop(Exit, Win) ->
    receive
	{gs, save, click, _Data, [Txt, Index | Rest]} ->
	    io:format("Save~n");
	{gs, load, click, _Data, [Txt, Index | Rest]} ->
	    io:format("Load~n");
	{gs, Exit, click, _Data, [Txt, Index | Rest]} ->
	    io:format("Exit~n"),
	    exit(normal);
	{gs, _MnuItem, click, {new_color, Color}, Args} ->
	    io:format("Change color to ~w. Args:~p~n", [Color, Args]),
	    gs:config(Win, [{bg, Color}]);
	{gs, doit, click, {doit, YouId, MeId}, Args} ->
	    HelpMe = gs:read(MeId, select),
	    HelpYou = gs:read(YouId, select),
	    io:format("Doit. HelpMe:~w, HelpYou:~w, Args:~p~n",
		      [HelpMe, HelpYou, Args]);
	Other -> io:format("Other:~p~n",[Other])
    end,
    loop(Exit, Win).
