%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%%% File    : gtk_gs.erl
%%% Author  : Klas Eriksson <eklas@ene>
%%% Purpose : The GS object
%%% Created : 21 Oct 1996 by Klas Eriksson <eklas@ene>
%%  Ericsson Software Technology AB / Erlang Systems

-module(gtk_gs).
-copyright('Copyright (c) 1991-97 Ericsson Telecom AB').
-vsn('$Revision: /main/release/free/1').
-author('eklas@ene').

-include("gtk.hrl").
-compile(export_all).
%%-export([Function/Arity, ...]).

%%----------------------------------------------------------------------
%% The GS object implementation
%%----------------------------------------------------------------------

mk_create_opts_for_child(DB,Cgtkid, Pgtkid, Opts) ->
    gtk_generic:mk_create_opts_for_child(DB,Cgtkid,Pgtkid,Opts).

config(DB, Gtkid, Opts) ->
    Cmd=gtk_generic:make_command(Opts,Gtkid,"",DB),
    gtk:exec(Cmd),
    ok.

read(DB, Gtkid, Opt) ->
    gtk_generic:read_option(DB, Gtkid, Opt).

% No options of my own
read_option(Option,Gtkid, TkW,DB,_) -> 
    {bad_result, {Gtkid#gtkid.objtype, invalid_option, Option}}.

option(Option, Gtkid, TkW, DB,_) ->
    invalid_option.
