%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%% ------------------------------------------------------------
%% Widget specific data
%% 
%% 1996-03-30	Written by Anders Dahlin, anders@erlang.ericcson.se
%%
%%  Ericsson Software Technology AB / Erlang Systems
%% ------------------------------------------------------------
%%

-module(gtk_widgets).
-copyright('Copyright (c) 1991-97 Ericsson Telecom AB').
-vsn('$Revision: /main/release/free/1').
-revision('$Revision: 1.8 $').
-author('anders@erlang.ericsson.se').
-modified('$Date: 1996/10/31 13:40:11 $').
-modified_by('$Author: eklas $').

-include("gtk.hrl").
%% ----- Exports -----
-compile(export_all).


%%
%% Map primitive types to modules or false (false should not be a module!)
%%
%% ordered for efficiency

type2mod(window)      -> gtk_window;
type2mod(frame)       -> gtk_frame;
type2mod(button)      -> gtk_button;
type2mod(canvas)      -> gtk_canvas;
type2mod(checkbutton) -> gtk_checkbutton;
type2mod(rectangle)   -> gtk_rectangle;
type2mod(gs)          -> gtk_gs;
type2mod(grid)        -> gtk_grid;
type2mod(gridline)    -> gtk_gridline;
type2mod(text)        -> gtk_text;
type2mod(image)       -> gtk_image;
type2mod(label)       -> gtk_label;
type2mod(line)        -> gtk_line;
type2mod(entry)       -> gtk_entry;
type2mod(listbox)     -> gtk_listbox;
type2mod(editor)      -> gtk_editor;
type2mod(menu)        -> gtk_menu;
type2mod(menubar)     -> gtk_menubar;
type2mod(menubutton)  -> gtk_menubutton;
type2mod(menuitem)    -> gtk_menuitem;
type2mod(message)     -> gtk_message;
type2mod(oval)        -> gtk_oval;
type2mod(polygon)     -> gtk_polygon;
type2mod(prompter)    -> gtk_prompter;
type2mod(radiobutton) -> gtk_radiobutton;
type2mod(scale)       -> gtk_scale;
type2mod(scrollbar)   -> gtk_scrollbar;
type2mod(arc)         -> gtk_arc;
type2mod(Type)        -> {error,{unknown_type, Type}}.

objmod(#gtkid{objtype=OT}) -> type2mod(OT).

%%
%% The suffix to add to the parent tk widget
%%
suffix(button)       -> ".b";
suffix(canvas)       -> ".c";
suffix(checkbutton)  -> ".cb";
suffix(editor)       -> ".ed";
suffix(entry)        -> ".e";
suffix(frame)        -> ".f";
suffix(label)        -> ".l";
suffix(listbox)      -> ".lb";
suffix(menu)         -> ".m";
suffix(menubar)      -> ".bar";
suffix(menubutton)   -> ".mb";
suffix(message)      -> ".ms";
suffix(prompter)     -> ".p";
suffix(radiobutton)  -> ".rb";
suffix(scale)        -> ".sc";
suffix(window)       -> ".w";
suffix(Objtype) -> apply(type2mod(Objtype), suffix, []).


