%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%%%*********************************************************************
%%%
%%%   Filename:         tv_pc_graph_ctrl.erl
%%%
%%%   Author:           EPK/TE  Fredrik Gustafson 
%%% 
%%%   SCCS Delta ID:    1.3
%%%
%%%   SCCS Delta Date:  97/06/12
%%%
%%%   SCCS ID:          @(#)  tv_pc_graph_ctrl.erl  1.3  97/06/12
%%%
%%%   Description:      
%%%
%%%*********************************************************************
%%%
%%%   COPYRIGHT ERICSSON TELECOM AB 1997
%%%
%%%   THE COPYRIGHT TO THE COMPUTER PROGRAM HEREIN IS THE
%%%   PROPERTY OF ERICSSON TELECOM AB, SWEDEN. THE PROGRAM
%%%   MAY BE USED AND/OR COPIED ONLY WITH THE WRITTEN PERMISSION
%%%   FROM ERICSSON TELECOM AB, OR IN ACCORDANCE WITH THE TERMS
%%%   AND CONDITIONS STIPULATED IN THE AGREEMENT/CONTRACT UNDER
%%%   WHICH THE PROGRAM HAS BEEN SUPPLIED.
%%%
%%%*********************************************************************
%%%
%%%   Revision information:
%%%
%%%   Date      Name                       Description
%%%   ------    -----------------------    -----------
%%%   970427    EPK/TE  F Gustafson        First version.
%%%
%%%
%%%*********************************************************************



-module(tv_pc_graph_ctrl).
-author('fredrik@erlang.ericsson.se').
-vsn('$Revision: /main/release/free/1').
-copyright('Copyright (C) 1991-97 Ericsson Telecom AB').



-export([create_menu/4, win_conf/2]).


-include("tv_int_msg.hrl").
-include("tv_pc_int_def.hrl").








%%%*********************************************************************
%%% EXTERNAL FUNCTIONS
%%%*********************************************************************




%%======================================================================
%% Function:      
%%
%% Return Value:  
%%
%% Description:   
%%
%% Parameters:    
%%======================================================================


create_menu(PwPid, MenuTitle, TitleAccPos, MenuList) ->
    PwPid ! #pw_create_menu{sender        = self(),
			    menutitle     = MenuTitle,
			    title_acc_pos = TitleAccPos,
			    menulist      = MenuList
			   },
    receive 
	#pw_create_menu_cfm{} ->
	    done
    after 10000 ->
	    exit(error)
    end.
    








%%======================================================================
%% Function:      win_conf.
%%
%% Return Value:  None.
%%
%% Description:   Configures all objects in the window according to new coordinates.
%%
%% Parameters:    
%%======================================================================


win_conf(Msg, ProcVars) ->
    #pc_win_conf{width  = NewWidth, 
		 height = NewHeight}  = Msg,

    #process_variables{pd_pid        = PdPid,
		       pw_pid        = PwPid,
		       window_params = WinP}  = ProcVars,
    
    #window_params{window_width  = OldWindowWidth,
		   window_height = OldWindowHeight}  = WinP,
		   

    case {NewWidth, NewHeight} of
	{OldWindowWidth, OldWindowHeight} ->
	    ProcVars;
	_Other ->
	    PdPid ! #pd_win_conf{sender = self(),
				 width  = NewWidth,
				 height = NewHeight
				},
	    NewWinP = WinP#window_params{window_width  = NewWidth,
					 window_height = NewHeight},
	    
	    ProcVars#process_variables{window_params = NewWinP}
    end.












